scoreboard players operation #Search Minion.ID = @s Minion.ID

# --------------------------------------------------------------------------------- #

# New Upgrade Module Placement
execute as @e[distance=..5, type=chest_minecart, tag=Minion.Menu, predicate=minion:check_id, limit=1] if items entity @s container.10 #minion:menu_modules[!custom_data={menu_item:1b}] if items entity @s container.10 #minion:menu_modules[max_stack_size=1] run function minion:handler/interaction/menu/events/upgrade_module



# New Storage Upgrade Placement
execute as @e[distance=..5, type=chest_minecart, tag=Minion.Menu, predicate=minion:check_id, limit=1] if items entity @s container.16 #minion:menu_storages[!custom_data={menu_item:1b}] if items entity @s container.16 #minion:menu_storages[max_stack_size=1] run function minion:handler/interaction/menu/events/upgrade_storage



# Remove Minion
execute if items entity @s player.cursor player_head[custom_data={menu_item:1b}] run function minion:handler/interaction/menu/events/claim
execute if items entity @s player.cursor player_head[custom_data={menu_item:1b}] run scoreboard players remove @s Minion.Placements 1
execute if items entity @s player.cursor player_head[custom_data={menu_item:1b}] run tellraw @s {"text": "Minion removed!", "color": "yellow"}
execute if items entity @s player.cursor player_head[custom_data={menu_item:1b}] run playsound block.anvil.destroy master @s
execute if items entity @s player.cursor player_head[custom_data={menu_item:1b}] as @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] run return run function minion:handler/interaction/menu/events/remove



# Claim Minion Storage
execute if items entity @s player.cursor barrel[custom_data={menu_item:1b}] run return run function minion:handler/interaction/menu/events/claim



# Remove Minion Module
execute if items entity @s player.cursor #minion:menu_modules[custom_data={menu_item:1b}] run return run function minion:handler/interaction/menu/events/remove_module



# Remove Minion Storage
execute if items entity @s player.cursor #minion:menu_storages[custom_data={menu_item:1b}] run return run function minion:handler/interaction/menu/events/remove_storage



# Minion Upgrade
execute if items entity @s player.cursor heavy_core[custom_data={menu_item:1b}] run return run function minion:handler/calculations/upgrade_minion with entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade"}]



# Static Menu Items
execute if items entity @s player.cursor #minion:static_menu_items[custom_data={menu_item:1b}] run return run function minion:handler/interaction/menu/events/invalid_item


# --------------------------------------------------------------------------------- #

# Clear menu items from inventory and hotbar
execute if items entity @s hotbar.* *[custom_data={menu_item:1b}] run clear @s *[custom_data={menu_item:1b}]
execute if items entity @s inventory.* *[custom_data={menu_item:1b}] run clear @s *[custom_data={menu_item:1b}]