data modify entity @s Items set from storage minions:zprivate menu_design
playsound minecraft:ui.button.click master @p[tag=Minion.In.Menu] ~ ~ ~

# --------------------------------------------------------------------------------- #

# Calculate all neccecarry values for the menu items before loading the menu


# Get the base cooldown value
data modify storage minions:zprivate string set from entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"cooldown"}].value

scoreboard players set $value Minion.Calc 0
function minion:handler/calculations/str_to_int
scoreboard players operation $cooldown Minion.Calc = $value Minion.Calc



# Get the cooldown reduction value
scoreboard players set $cooldown_reduction Minion.Calc 100

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":"Control Node"}] run scoreboard players set $cooldown_reduction Minion.Calc 95

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":"Stabilization Unit"}] run scoreboard players set $cooldown_reduction Minion.Calc 93

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":"Thermal Regulation Unit"}] run scoreboard players set $cooldown_reduction Minion.Calc 90

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":"Energy Redistribution Core"}] run scoreboard players set $cooldown_reduction Minion.Calc 85


scoreboard players operation $cooldown Minion.Calc *= $cooldown_reduction Minion.Calc
scoreboard players operation $cooldown Minion.Calc /= $100 Minion.Constant



# Get external buff cooldown value
scoreboard players set $external_cooldown_reduction Minion.Calc 100

execute as @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] at @s if entity @e[distance=..5, type=item_display, tag=Minion.External_Buff] run scoreboard players set $external_cooldown_reduction Minion.Calc 97

scoreboard players operation $cooldown Minion.Calc *= $external_cooldown_reduction Minion.Calc
scoreboard players operation $cooldown Minion.Calc /= $100 Minion.Constant




# tellraw @a [{"text":"Base Cooldown: ","color":"gray","italic":false},{"score":{"name":"$cooldown","objective":"Minion.Calc"}}]

scoreboard players reset $cooldown_minutes Minion.Calc

# Get the cooldown minutes value
execute if score $cooldown Minion.Calc matches 60.. run scoreboard players operation $cooldown_minutes Minion.Calc = $cooldown Minion.Calc
execute if score $cooldown Minion.Calc matches 60.. run scoreboard players operation $cooldown_minutes Minion.Calc /= $60 Minion.Constant

# Get the cooldown seconds value
scoreboard players operation $cooldown_seconds Minion.Calc = $cooldown Minion.Calc
scoreboard players operation $cooldown_seconds Minion.Calc %= $60 Minion.Constant

# tellraw @a [{"text":"Cooldown: ","color":"gray","italic":false},{"score":{"name":"$cooldown_minutes","objective":"Minion.Calc"}},{"text":"m, ","color":"gray","italic":false},{"score":{"name":"$cooldown_seconds","objective":"Minion.Calc"}},{"text":"s","color":"gray","italic":false}]

execute if score $cooldown_minutes Minion.Calc matches 1.. store result storage minions:zprivate minion.cooldown.minutes int 1 run scoreboard players get $cooldown_minutes Minion.Calc
execute store result storage minions:zprivate minion.cooldown.seconds int 1 run scoreboard players get $cooldown_seconds Minion.Calc

function minion:handler/calculations/convert_cooldown with storage minions:zprivate minion.cooldown
# tellraw @a {"nbt": "minion.cooldown.output", "storage": "minions:zprivate"}


# Get current storage values
data modify storage minions:zprivate string set from entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage"}].value

scoreboard players set $value Minion.Calc 0
function minion:handler/calculations/str_to_int
scoreboard players operation $minion_storage Minion.Calc = $value Minion.Calc


# Get the max storage value
data modify storage minions:zprivate string set from entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage"}].signature

scoreboard players set $value Minion.Calc 0
function minion:handler/calculations/str_to_int
scoreboard players operation $minion_max_storage Minion.Calc = $value Minion.Calc


# Get the storage upgrade value
scoreboard players set $storage_expansion Minion.Calc 0

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage_upgrade", "value":"Storage Capacity Disk"}] run scoreboard players set $storage_expansion Minion.Calc 16

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage_upgrade", "value":"Data Capacity Expander"}] run scoreboard players set $storage_expansion Minion.Calc 32

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage_upgrade", "value":"Chip Expansion Board"}] run scoreboard players set $storage_expansion Minion.Calc 64

scoreboard players operation $minion_max_storage Minion.Calc += $storage_expansion Minion.Calc



# Check for special minions with a max storage cap
execute if score $minion_max_storage Minion.Calc matches 101.. if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"type","value":"lava"}] run scoreboard players set $minion_max_storage Minion.Calc 100





# --------------------------------------------------------------------------------- #

# Set the Minion Upgrade Module item

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":""}] run loot replace entity @s container.10 loot minion:menu/upgrade_module

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":"Control Node"}] run data modify entity @s Items append value {Slot:10, id: "amethyst_shard", count: 1, components: {"minecraft:lore": ['{"text": "Enhance your minion\'s efficiency","color": "gray","italic": false}','{"text": "by installing an upgrade module.","color": "gray","italic": false}','""','{"color":"gray","italic":false,"text":"Current Upgrade Module:"}','{"color":"yellow","italic":false,"text":"> Control Node <"}', '""', '{"color":"aqua","italic":false,"text":"Enhances your minion\'s speed"}', '{"color":"aqua","italic":false,"text":"by 5%."}', '""', '{"color":"gray","italic":false,"text":"Click to remove module."}'], "minecraft:max_stack_size": 1, "minecraft:custom_name": '{"color":"green","italic":false,"text":"Upgrade Module"}', "minecraft:custom_data": {menu_item: 1b}}}

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":"Stabilization Unit"}] run data modify entity @s Items append value {Slot:10, id: "breeze_rod", count: 1, components: {"minecraft:lore": ['{"text": "Enhance your minion\'s efficiency","color": "gray","italic": false}','{"text": "by installing an upgrade module.","color": "gray","italic": false}','""','{"color":"gray","italic":false,"text":"Current Upgrade Module:"}', '{"color":"yellow","italic":false,"text":"> Stabilization Unit <"}', '""', '{"color":"aqua","italic":false,"text":"Enhances your minion\'s speed"}', '{"color":"aqua","italic":false,"text":"by 7%."}', '""', '{"color":"gray","italic":false,"text":"Click to remove module."}'], "minecraft:max_stack_size": 1, "minecraft:custom_name": '{"color":"green","italic":false,"text":"Upgrade Module"}', "minecraft:custom_data": {menu_item: 1b}}}

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":"Thermal Regulation Unit"}] run data modify entity @s Items append value {Slot:10, id: "blaze_powder", count: 1, components: {"minecraft:lore": ['{"text": "Enhance your minion\'s efficiency","color": "gray","italic": false}','{"text": "by installing an upgrade module.","color": "gray","italic": false}','""','{"color":"gray","italic":false,"text":"Current Upgrade Module:"}', '{"color":"yellow","italic":false,"text":"> Thermal Regulation Unit <"}', '""', '{"color":"aqua","italic":false,"text":"Enhances your minion\'s speed"}', '{"color":"aqua","italic":false,"text":"by 10%."}', '""', '{"color":"gray","italic":false,"text":"Click to remove module."}'], "minecraft:max_stack_size": 1, "minecraft:custom_name": '{"color":"green","italic":false,"text":"Upgrade Module"}', "minecraft:custom_data": {menu_item: 1b}}}

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"upgrade_module", "value":"Energy Redistribution Core"}] run data modify entity @s Items append value {Slot:10, id: "nether_star", count: 1, components: {"minecraft:lore": ['{"text": "Enhance your minion\'s efficiency","color": "gray","italic": false}','{"text": "by installing an upgrade module.","color": "gray","italic": false}','""','{"color":"gray","italic":false,"text":"Current Upgrade Module:"}', '{"color":"yellow","italic":false,"text":"> Energy Redistribution Core <"}', '""', '{"color":"aqua","italic":false,"text":"Enhances your minion\'s speed"}', '{"color":"aqua","italic":false,"text":"by 15%."}', '""', '{"color":"gray","italic":false,"text":"Click to remove module."}'], "minecraft:max_stack_size": 1, "minecraft:custom_name": '{"color":"green","italic":false,"text":"Upgrade Module"}', "minecraft:custom_data": {menu_item: 1b}}}


# --------------------------------------------------------------------------------- #


# Set the Minion Upgrade to next tier item
data modify storage minions:zprivate string set from entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"tier"}].value

scoreboard players set $value Minion.Calc 0
function minion:handler/calculations/str_to_int

scoreboard players operation $next_tier Minion.Calc = $value Minion.Calc
scoreboard players add $next_tier Minion.Calc 1

execute if score $next_tier Minion.Calc matches 2 run scoreboard players set $next_tier_costs Minion.Calc 16
execute if score $next_tier Minion.Calc matches 3 run scoreboard players set $next_tier_costs Minion.Calc 32
execute if score $next_tier Minion.Calc matches 4 run scoreboard players set $next_tier_costs Minion.Calc 64
execute if score $next_tier Minion.Calc matches 5 run scoreboard players set $next_tier_costs Minion.Calc 128

execute if score $value Minion.Calc matches 1..4 run loot replace entity @s container.11 loot minion:menu/upgrade_minion
execute if score $value Minion.Calc matches 5 run loot replace entity @s container.11 loot minion:menu/max_tier

# --------------------------------------------------------------------------------- #


# Set the Minion Information item
function minion:handler/calculations/macro_block_check with entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"resource"}]


# --------------------------------------------------------------------------------- #


# Set the Minion Items item
loot replace entity @s container.15 loot minion:menu/minion_items

execute unless entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1, tag=Minion.Cannot_Work] unless score $minion_storage Minion.Calc >= $minion_max_storage Minion.Calc run function minion:handler/calculations/get_timestamp

# --------------------------------------------------------------------------------- #


# Set the Minion Storage item
execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage_upgrade", "value":""}] run loot replace entity @s container.16 loot minion:menu/upgrade_storage

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage_upgrade", "value":"Storage Capacity Disk"}] run data modify entity @s Items append value {Slot:16, id: "gray_dye", count: 1, components: {"minecraft:lore": ['{"color":"gray","italic":false,"text":"Upgrade your minion storage to be"}', '{"color":"gray","italic":false,"text":"able to store more items at once."}', '""', '{"color":"gray","italic":false,"text":"Current Storage Upgrade:"}', '{"color":"light_purple","italic":false,"text":"> Storage Capacity Disk <"}', '""', '{"color":"aqua","italic":false,"text":"Upgrades your minion storage"}', '{"color":"aqua","italic":false,"text":"with 16 more items at once."}', '""', '{"color":"gray","italic":false,"text":"Click to remove storage expansion."}'], "minecraft:custom_name": '{"color":"green","italic":false,"text":"Storage Upgrade"}', "minecraft:custom_data": {menu_item: 1b}}}

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage_upgrade", "value":"Data Capacity Expander"}] run data modify entity @s Items append value {Slot:16, id: "lime_dye", count: 1, components: {"minecraft:lore": ['{"color":"gray","italic":false,"text":"Upgrade your minion storage to be"}', '{"color":"gray","italic":false,"text":"able to store more items at once."}', '""', '{"color":"gray","italic":false,"text":"Current Storage Upgrade:"}', '{"color":"light_purple","italic":false,"text":"> Data Capacity Expander <"}', '""', '{"color":"aqua","italic":false,"text":"Upgrades your minion storage"}', '{"color":"aqua","italic":false,"text":"with 32 more items at once."}', '""', '{"color":"gray","italic":false,"text":"Click to remove storage expansion."}'], "minecraft:custom_name": '{"color":"green","italic":false,"text":"Storage Upgrade"}', "minecraft:custom_data": {menu_item: 1b}}}

execute if data entity @e[distance=..10, type=armor_stand, tag=Minion, predicate=minion:check_id, limit=1] ArmorItems[3].components."minecraft:profile".properties[{"name":"storage_upgrade", "value":"Chip Expansion Board"}] run data modify entity @s Items append value {Slot:16, id: "light_blue_dye", count: 1, components: {"minecraft:lore": ['{"color":"gray","italic":false,"text":"Upgrade your minion storage to be"}', '{"color":"gray","italic":false,"text":"able to store more items at once."}', '""', '{"color":"gray","italic":false,"text":"Current Storage Upgrade:"}', '{"color":"light_purple","italic":false,"text":"> Chip Expansion Board <"}', '""', '{"color":"aqua","italic":false,"text":"Upgrades your minion storage"}', '{"color":"aqua","italic":false,"text":"with 64 more items at once."}', '""', '{"color":"gray","italic":false,"text":"Click to remove storage expansion."}'], "minecraft:custom_name": '{"color":"green","italic":false,"text":"Storage Upgrade"}', "minecraft:custom_data": {menu_item: 1b}}}